Fixed bug with new SCALE variable setting for mencoder
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
39
40 ###############################################
41 # Command line processing
42 typeset dvdname=""
43 typeset debug=""
44 typeset dest=""
45 typeset isofile=""
46 typeset vobfile=""
47 typeset dvdpath=""
48 typeset aspect=""
49 typeset SCALE=""
50 typeset CROP=""
51 typeset -i keep_intermediate_files=0
52 typeset -i make_final_dest_vob=0
53 typeset -i make_final_dest_iso=0
54 typeset -i make_final_dest_folder=0
55 typeset -i make_final_dest_avi=0
56 typeset -i errors=0
57 typeset -i show_usage=0
58 typeset -i mirror_mode=0
59 typeset -i target_bitrate=0
60 typeset -i target_size=0
61 typeset -i audio_2ch=0
62 typeset -i invalid_feature_title=0
63 typeset -i feature_title_override=0
64 typeset -i mplayer_dumpstream_incompatibility=0
65
66 while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a: opt "$@"
67 do
68     case $opt in
69         (n)     dvdname=$OPTARG;;
70         (d)     dest=$OPTARG;;
71         (b)     target_bitrate=$OPTARG;;
72         (s)     target_size=$OPTARG;;
73         (2)     audio_2ch=1;;
74         (v)     make_final_dest_vob=1;;
75         (i)     make_final_dest_iso=1;;
76         (f)     make_final_dest_folder=1;; 
77         (x)     make_final_dest_avi=1;;
78         (m)     mirror_mode=1;;
79         (k)     keep_intermediate_files=1;;
80         (t)     feature_title_override=$OPTARG;;
81         (a)     aspect=$OPTARG;;
82         (w)     set -$opt;;
83         (h)     show_usage=1;;
84         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
85         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
86     esac
87 done
88
89 shift $((OPTIND-1))
90
91 function usage() {
92     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
93     echo >&2 "Revision $REV"
94     echo >&2 "Options:"
95     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
96     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
97     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
98     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
99     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
100     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
101     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
102     echo >&2 "                 The default operation is non-mirror mode where only the main"
103     echo >&2 "                 feature title will be ripped."
104     echo >&2 "   -v            Make the final image a DVD VOB file"
105     echo >&2 "   -i            Make the final image a DVD ISO file"
106     echo >&2 "   -f            Make the final image a DVD folder"
107     echo >&2 "   -x            Make the final image an AVI (XVID) file"
108     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
109     echo >&2 "   -s <size>     Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
110     echo >&2 "   -b <bitrate>  Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"    
111     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
112     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
113     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
114     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
115     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
116     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
117     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
118     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
119     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
120     echo >&2 ""
121     exit 2
122 }
123
124 if (($errors)) || (($show_usage))
125 then
126   usage
127 fi
128
129 # Sanity Check - Command Line Options 
130 if [ "$dest" == "" ]; then
131   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
132   usage
133 fi
134
135 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_avi -ne 1 ]; then
136   echo "-E- You can't specify a bitrate, target_size, or aspect in non AVI file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
137   usage
138 fi
139
140 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
141   echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
142   usage
143 fi
144
145 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
146    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
147   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
148   usage
149 fi
150
151 if [ $mirror_mode -eq 1 ]; then
152   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
153      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
154     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
155     usage
156   fi
157 fi
158
159 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
160 if [ "$aspect" != "" ]; then
161   echo "$aspect" | grep -q "x"
162   if [ $? == 0 ]; then
163     echo "-E- You must specify the aspect option with a value whose format is W:H"
164     exit 1
165   fi
166   echo "$aspect" | grep -q ":"
167   if [ $? != 0 ]; then
168     SCALE=",scale -zoom -xy $aspect"
169   else
170     SCALE=",scale=$aspect"
171   fi
172 fi
173
174
175 # Sanity Check - Key executables
176 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
177 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
178 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
179 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
180 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
181 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
182 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
183 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
184
185 ###############################################
186
187 typeset -i ripdvd
188 if [ -z "$dvdname" ]; then
189   # make sure the DVD device is accessible
190   volname $dev > /dev/null 2>&1
191   if [ $? != 0 ]; then
192     echo "-E- Can't access the DVD device $dev"
193     exit 1
194   fi
195   # now capture the volume name from the device
196   dvdname=`volname $dev | awk '{ print $1 }'`
197   ripdvd=1
198 else 
199   # check to see if dvdname is a full path to a real directory
200   # if it is, set dvdname and dvdpath appropriately
201   if [ -d "$dvdname" ]; then
202     dvdpath="$dvdname"
203     dvdname=`basename "$dvdname"`
204     if [ -z "$dvdname" ]; then
205      echo "-E- Unable to extract dvdname from path: $dvdpath"
206      exit 1
207     fi
208     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
209       echo "-E- You must supply a full path to a valid DVD folder with this option"
210       exit 1
211     fi
212   fi
213   # check to see if dvdname is a full path to an MPG2 (VOB) file
214   # if it is, set dvdname and vobfile appropriately
215   if [ -f "$dvdname" ]; then
216     vobfile="$dvdname"
217     dvdname=`basename "$dvdname"`
218     file "$vobfile" | grep -q "MPEG"
219     if [ $? == 0 ]; then
220       # It is a valid MPEG2 file, now strip the extension off our dvdname
221       dvdname=${dvdname%.[^.]*}
222     else 
223       echo "-E- Unsupported file type: $vobfile"
224       exit 1
225     fi
226   fi
227   ripdvd=0
228 fi
229
230 # remove bad characters from the dvdname
231 dvdname=${dvdname%.} # remove trailing '.' character
232
233 # make a "safe" dvdname (remove special characters)
234 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
235
236 # Make sure we have a non-empty dvdname
237 if [ -z "$dvdname" ]; then
238   echo "-E- unable to determine dvdname"
239   exit 1
240 fi
241
242 # make sure our vobfile value is set
243 if [ -z "$vobfile" ]; then
244   vobfile="$dest/$dvdname.VOB"
245 fi
246
247 # set up some variables to hold various logfiles
248 logfile="$logdir/$dvdname.log"
249 passlogfile="$tmpdir/$safedvdname.log"
250 ddrescuelog=`tempfile`
251 dvdauthorlog=`tempfile`
252 encodelog=`tempfile`
253 dumplog=`tempfile`
254
255 # create the tmpdir if it doesn't already exist
256 if [ ! -d "$tmpdir" ]; then
257   mkdir -p "$tmpdir"
258   if [ $? != 0 ]; then
259     echo "-E- Unable to create the tmpdir: $tmpdir"
260     exit 1
261   fi
262 fi
263
264 # create the logdir if it doesn't already exist
265 if [ ! -d "$logdir" ]; then
266   mkdir -p "$logdir"
267   if [ $? != 0 ]; then
268     echo "-E- Unable to create the logdir: $logdir"
269     exit 1
270   fi
271 fi
272
273 ###############################################
274 # cleanup functions
275 cleanup() { 
276   if [ $keep_intermediate_files -eq 0 ]; then
277     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
278     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
279     [[ -e "$encodelog" ]] && rm -f "$encodelog"
280     [[ -e "$dumplog" ]] && rm -f "$dumplog"
281   else
282     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
283     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
284     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
285     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
286   fi
287   echo ""
288 }
289
290 fatal_and_exit() {
291   if [[ -z "$1" ]]; then
292     msg="-E- control-c killed us"
293   else
294     msg=$1
295   fi
296   echo -e 2>&1 "$msg" | tee -a "$logfile"
297   if [[ -n "$mailto" ]]; then
298     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
299   fi
300   exit 1
301 }
302
303 # Call our cleanup functions on INT and EXIT signals
304 trap fatal_and_exit INT
305 trap cleanup EXIT
306
307 ###############################################
308 # processing functions
309 function make_dvd_iso_image {
310
311   isofile="$1"
312
313   # check to see if we have a dvdpath to rip from instead of $dev
314   if [ -z "$dvdpath" ]; then
315     # load the CSS codes in the DVD drive 
316     lsdvd $dev >> "$logfile"
317     if [ $? != 0 ]; then
318       fatal_and_exit "-E- lsdvd $dev failed" 
319     fi
320
321     # read the DVD, ignoring/skipping CRC errors
322     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
323     if [ $? != 0 ]; then
324       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
325     fi
326     cat "$ddrescuelog" >> "$logfile"
327   else
328     # rip from a path instead
329     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
330   fi
331 }
332
333 function make_dvd_iso_image_from_folder {
334   
335   src="$1"
336   dst="$2"
337   handle_error=$3
338   
339   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
340
341   # make an iso image out of our directory
342   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
343   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
344
345   # set the audio languages from the iso if it exists and is non-zero in size
346   if [ -s "$dst" ]; then
347     get_feature_title "$dst"
348     get_audio_id_from_iso "$dst"
349   fi
350
351   # make sure we were able to create the iso image from the folder given to us
352   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
353     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
354     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
355     # remove the bad iso file
356     [[ -e "$dst" ]] && rm -f "$dst"
357     # get the feature title from the DVD folder
358     get_feature_title "$dvdpath"
359     # create our main VOB file from the ISO
360     create_main_vob_with_mplayer "$dvdpath" 
361     # get our audio id from the VOB file
362     get_audio_id_from_vob "$vobfile"
363   fi
364 }
365
366 function make_dvdbackup_folder_image {
367   # extract the feature title from the DVD image
368   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
369   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
370   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
371   if [ $? != 0 ]; then
372     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
373   fi
374 }
375
376 function make_dvdauthor_folder_image {
377   # create a new DVD video of the feature title
378   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
379   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
380   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
381   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
382
383   # There is a chance that dvdauthor won't like some of the VOBs.
384   # We can't tell ahead of time which ones it will choke on. 
385   # So, we need to run it over and over again until it can process
386   # all the VOBs. If it can't handle one of them, run it through
387   # mencoder to fix it and try again. These errors are typically
388   # present due to the copy protection that ddrescue removed.
389   grep -q "SCR moves" $dvdauthorlog
390   while [ $? == 0 ]; do
391     # fix bad vobs that get the "SCR moves backwards" error:
392     #  STAT: Processing VTS_01_0.VOB...
393     #  ERR:  SCR moves backwards, remultiplex input.
394     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
395     if [[ ! -f "$badvob" ]]; then
396       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
397     fi
398     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
399     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
400     mv -f $badvob.fixed $badvob
401     echo "-> Creating DVD video $dest/$dvdname"
402     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
403     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
404     grep -q "SCR moves" $dvdauthorlog
405   done
406 }
407
408 function get_feature_title {
409   source="$1"
410   # if a feature title was given on the command line, use it
411   if [ $feature_title_override -ne 0 ]; then
412     feature_title=$feature_title_override
413     return 0
414   fi
415   # otherwise, use lsdvd to figure it out
416   if [ $ripdvd -eq 1 ]; then
417     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
418   else 
419     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
420   fi
421 }
422
423 function create_main_vob_with_cat {
424   # cd to the feature title DVD folder
425   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
426   if [ $? != 0 ]; then
427     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
428   fi
429
430   # concatenate all the VOBs together into 1 giant VOB
431   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
432   cat $vobs > "$tmpdir/$dvdname.VOB"
433
434   # cd back to the dir we started from
435   popd > /dev/null 2>&1
436 }
437
438 function create_main_vob_with_mplayer {
439
440   # argument processing  
441   source="$1"
442   remove_dumplog=$2
443
444   # make sure we have a valid feature title
445   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
446     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
447   fi
448
449   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
450   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
451     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
452     msg="$msg We also detected another condition that requires us to use dumpstream. "
453     msg="$msg\n    Unable to rip this DVD in the mode you requested."
454     fatal_and_exit "$msg"
455   fi
456
457   # use mplayer to create the main VOB file
458   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
459   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
460   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
461   if [ $? != 0 ]; then
462     cat $dumplog | grep -v "^A:" >> "$logfile"
463     fatal_and_exit "-E- Mplayer Failed"
464   fi
465   cat $dumplog | grep -v "^A:" >> "$logfile"
466   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
467 }
468
469 function get_audio_id_from_iso {
470   # Adjust our audio ID to find the english audio stream
471   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
472   iso="$1"
473   aidcheck=`tempfile`
474   aid=128
475   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
476   grep -q "aid: $aid" $aidcheck
477   while [ $? == 1 ] && [ $aid -lt 159 ]; do
478     (( aid = aid + 1 ))
479     grep -q "aid: $aid" $aidcheck
480   done
481   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
482   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
483   # mencoder default DVD audio track language selection (english)
484   lang_opts="-aid $aid -alang en"
485 }
486
487 function get_crop_from_iso { 
488   FRAMES=10000
489   echo "-> Detecting black frame border crop value from ISO file"
490   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
491   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
492   [[ -e "md5sums" ]] && rm -f "md5sums"
493   CROP=`cat $dumplog | grep CROP | tail -1`
494   echo "   Found crop value of $CROP" >> "$logfile"
495   CROP=${CROP#* crop=}
496   CROP=${CROP%%\).*}
497   typeset -i CROPCHECK
498   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
499   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
500   if [ -z "$CROP" ]; then
501     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
502   fi
503   if [ $CROPCHECK -lt 0 ]; then 
504     CROP=""
505   else 
506     CROP=",crop=$CROP"
507   fi
508   echo "   Setting mencoder crop filter to: $CROP"
509 }
510
511 function get_audio_id_from_vob {
512   # Adjust our audio ID to find the english audio stream
513   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
514   vob="$1"
515   aidcheck=`tempfile`
516   aid=128
517   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
518   grep -q "Found audio stream: $aid" $aidcheck
519   while [ $? == 1 ] && [ $aid -lt 159 ]; do
520     (( aid = aid + 1 ))
521     grep -q "Found audio stream: $aid" $aidcheck
522   done
523   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
524   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
525   # mencoder default DVD audio track language selection (english)
526   lang_opts="-aid $aid -alang en"
527 }
528
529 function check_vob_for_corrupted_start {
530   # check to see if the beginning of the DVD has a form of copy protection
531   # where they have deliberately broken the first X number of frames of the DVD.
532   # If we don't skip these, our resulting VOB file will not play.
533   badvobcheck=`tempfile`
534   endpos=360
535   skip=0
536   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
537   if [ $? != 0 ]; then
538     fatal_and_exit "-E- Mencoder Failed"
539   fi
540   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
541   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
542     (( skip = skip + 5 ))
543     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
544     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
545     if [ $? != 0 ]; then
546       fatal_and_exit "-E- Mencoder Failed"
547     fi
548     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
549   done
550   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
551
552   # cat the giant VOB into mencoder to create a playable VOB file
553   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
554   if [ $? != 0 ]; then
555     fatal_and_exit "-E- Mencoder Failed"
556   fi
557 }
558
559 function check_vob_for_completeness {
560   # check to make sure we got out a complete VOB.
561   # there is another kind of copy protection where the VOB's may
562   # have "MPG EOF" frames in the middle of the stream. 
563   # this causes mencoder to not process the entire VOB, and exit without any errors.
564   # detect this by seeing how much smaller the dst vob is from the src vob.
565   MAX_FILESIZE_DELTA_PERCENT=70
566   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
567   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
568   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
569   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
570     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
571     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
572     create_main_vob_with_mplayer "$isofile"
573     [[ -e "$dumplog" ]] && rm -f $dumplog
574     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
575     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
576     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
577       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
578     fi
579   fi
580 }
581
582 function check_vob_for_too_many_video_packets {
583   # If our earlier algorithm to work around this failed, throw an error.
584   # check to see if this DVD has a protection scheme we don't know how to work around
585   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
586   # for some reason, the video is black, while the audio rolls, then the video finally comes
587   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
588   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
589   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
590   grep -q "Too many video packets in the buffer:" "$logfile"
591   if [ $? == 0 ]; then
592     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
593     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
594     create_main_vob_with_mplayer "$isofile"
595     grep -q "Too many video packets in the buffer:" $dumplog
596     if [ $? == 0 ]; then
597       [[ -e "$dumplog" ]] && rm -f $dumplog
598       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
599     fi
600     [[ -e "$dumplog" ]] && rm -f $dumplog
601   fi
602 }
603
604 function check_vob_for_a52_crc_errors {
605   # Let's see if we can playback our newly created VOB file without any errors.
606   # if there are issues, let's detect them now, and try to recreate the VOB
607   # there are some forms of copy protection that have missed above, that evidence
608   # themselves when we try to playback the VOB file. This was added to deal with
609   # the "a52: CRC check failed" copy protection scheme.
610   MAX_ERRORS=10
611   ENDPOS=120
612   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
613   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
614   cat $dumplog | grep -v "^A:" >> "$logfile"
615   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
616   if [ $errors -gt $MAX_ERRORS ]; then
617     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
618     create_main_vob_with_mplayer "$isofile"
619     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
620     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
621     if [ $? != 0 ]; then
622       cat $dumplog | grep -v "^A:" >> "$logfile"
623       fatal_and_exit "-E- Mplayer Failed"
624     fi
625     cat $dumplog | grep -v "^A:" >> "$logfile"
626     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
627     if [ $errors -gt $MAX_ERRORS ]; then
628       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
629     fi
630   fi
631   [[ -e "$dumplog" ]] && rm -f $dumplog
632 }
633
634 function calculate_bitrate_from_target_size {
635   # determine what our bitrate needs to be if a target size was specified instead
636   if [ $target_size -ne 0 ]; then
637     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
638     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
639     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
640   fi
641 }
642
643 function create_dvdauthor_dvd_xml_file {
644   # make a dvdauthor xml menu file to create a valid DVD video from 
645   # this script does a good job, but we'll still need to clean it up a bit after it runs
646   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
647   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
648   if [ $? != 0 ]; then
649     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
650   fi
651
652   # replace the first line of the xml file to remove the bad dest path
653   awk -v line=1 -v new_content="<dvdauthor>" '{
654     if (NR == line) {
655       print new_content;
656     } else {
657       print $0;
658     }
659   }' dvd.xml > dvd.xml.new
660   mv -f dvd.xml.new dvd.xml
661   if [ $? != 0 ]; then
662     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
663   fi
664
665   # remove the "<video " property line from the xml file
666   cat dvd.xml | grep -v "<video" > dvd.xml.new
667   mv -f dvd.xml.new dvd.xml
668   if [ $? != 0 ]; then
669     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
670   fi
671   
672   # remove the extra <pgc>..</pgc> pairs
673   cat dvd.xml | awk 'BEGIN {x=1}
674   {
675     if ($0~"</pgc>") {x=0}
676     if (x==1) {print $0}
677     if ($0~"<pgc>") {x=1}
678   }' > dvd.xml.new
679   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
680   mv -f dvd.xml.new dvd.xml
681   if [ $? != 0 ]; then
682     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
683   fi
684
685   # remove the VTS_*_0.VOB file as this is just the main menu video clip
686   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
687   mv -f dvd.xml.new dvd.xml
688   if [ $? != 0 ]; then
689     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
690   fi
691 }
692
693 function check_for_mplayer_dumpstream_incompatibility {
694
695   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
696
697   if [ ! -e "$vobfile" ]; then
698     # mplayer dumpstream does not work on DVDs that obscure the feature title.
699     # A DVD that has 99 titles, where the longest title isn't the main feature
700     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
701     # out what the feature title is. This script will run through that flow if we
702     # set use_mplayer_dumpstream to 0. Check for this here.
703     if [ $ripdvd -eq 1 ]; then
704       lsdvd $dev | grep -q "Title: 99"
705     else
706       lsdvd "$isofile" | grep -q "Title: 99"
707     fi
708     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
709     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
710       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
711         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
712         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
713         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
714         invalid_feature_title=1
715       else 
716         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
717         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
718         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
719         use_mplayer_dumpstream=0
720         invalid_feature_title=1
721       fi
722       return
723     fi
724   fi
725
726   # There is another form of protection that causes the mplayer dumpstream to fail. 
727   # This can be detected by telling mplayer to parse the VOB file by copying its audio
728   # video streams to a dummy output file (/dev/null). Do that here to check for that 
729   # problem before continuing.
730   if [ -e "$vobfile" ]; then
731     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
732     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
733     grep -q "Too many audio packets in the buffer" $dumplog
734     if [ $? == 0 ]; then
735       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
736       use_mplayer_dumpstream=0
737       mplayer_dumpstream_incompatibility=1
738     fi
739     [[ -e "$dumplog" ]] && rm -f $dumplog
740   fi
741 }
742
743 function fill_mythvideo_metadata {
744
745   # This function must be passed the filename as an argument
746   # The filename must be a full path to the file
747   filename="$1"
748
749   # Make sure the fill mythvideo metadata option has been set to 1
750   if [ $fill_mythvideo_metadata -eq 0 ]; then
751     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
752     return 0
753   fi
754
755   # If the fill mythvideo metadata script is present, run it
756   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
757   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
758     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
759     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
760   else
761     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
762     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
763   fi
764 }
765
766 function remove_intermediate_vob_file {
767   # remove the intermediate VOB file
768   if [ $keep_intermediate_files -eq 0 ]; then
769     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
770   else
771     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
772   fi
773 }
774
775 function remove_intermediate_iso_file {
776   # remove the original DVD image 
777   if [ $keep_intermediate_files -eq 0 ]; then
778     [[ -e "$isofile" ]] && rm "$isofile"
779   else
780     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
781   fi
782 }
783
784 function remove_intermediate_dvdbackup_folder {
785   if [ $keep_intermediate_files -eq 0 ]; then
786     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
787   else
788     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
789   fi
790 }
791
792 ###############################################
793 # MAIN
794
795 # Make a note of when this DVD rip started
796 date=`date`
797 echo -e "\n$date DVD rip started" >> "$logfile"
798
799 # Rip the DVD - Mirror Mode
800 if [ $mirror_mode -eq 1 ]; then
801   echo "-> Ripping DVD $dvdname to $dest"
802
803   # use ddrescue to make an ISO image of the disk
804   make_dvd_iso_image "$dest/$dvdname.iso"
805
806   # add this video data to the mythtv DB
807   fill_mythvideo_metadata "$dest/$dvdname.iso" 
808
809   # eject the disk upon completion
810   eject -T $dev
811
812   date=`date`
813   echo "$date DVD rip completed" | tee -a "$logfile"
814
815   if [[ -n "$mailto" ]]; then
816     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
817   fi
818
819 fi
820
821 # Rip the DVD - Main Title Feature Only
822 if [ $mirror_mode -eq 0 ]; then
823
824   # Rip image from DVD
825   if [ $ripdvd -eq 1 ]; then
826     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
827     # use ddrescue to make an ISO image of the disk
828     make_dvd_iso_image "$tmpdir/$dvdname.iso"
829   fi
830
831   # Rip image from DVD path
832   if [ -n "$dvdpath" ]; then
833     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
834     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
835   fi
836
837   # make sure our isofile value is set
838   if [ -z "$isofile" ]; then
839     isofile="$tmpdir/$dvdname.iso"
840   fi
841      
842   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
843
844     if [ ! -e "$vobfile" ]; then
845       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
846       
847       # get the feature title from the ISO
848       get_feature_title "$isofile"
849  
850       # get the crop value from the ISO
851       get_crop_from_iso
852
853       # check for mplayer dumpstream incompatibilities
854       # if they exist, this method will set this mode to 0.
855       check_for_mplayer_dumpstream_incompatibility
856
857       if [ $use_mplayer_dumpstream -eq 1 ]; then 
858
859         # get our audio id from the ISO file
860         get_audio_id_from_iso "$isofile"
861
862         # create our main VOB file from the ISO
863         create_main_vob_with_mplayer "$isofile"
864      
865         # remove the intermediate VOB file
866         remove_intermediate_vob_file
867
868         # it's possible that our VOB is still corrupted in some manner
869         # check to make sure it is still a good VOB before continuing.
870         check_for_mplayer_dumpstream_incompatibility
871
872       fi
873  
874       if [ $use_mplayer_dumpstream -eq 0 ]; then 
875
876         # use dvdbackup to make a DVD folder of the feature title
877         make_dvdbackup_folder_image
878   
879         # create our main VOB file
880         create_main_vob_with_cat
881
882         # get our audio id from the VOB file
883         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
884   
885         # check for corrupted VOB start
886         check_vob_for_corrupted_start
887  
888         # check to make sure our VOB is complete
889         check_vob_for_completeness
890
891         # check to make sure our VOB doesn't have too many video packets
892         check_vob_for_too_many_video_packets
893
894         # check to make sure our VOB doesn't have a52 crc errors
895         check_vob_for_a52_crc_errors
896
897         # remove the intermediate VOB file
898         remove_intermediate_vob_file
899
900       fi
901
902       # remove the intermediate ISO file
903       remove_intermediate_iso_file
904
905     else
906       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
907     fi
908
909     # transcode the DVD
910     if [ $make_final_dest_avi -eq 1 ]; then
911       echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
912
913       # determine what our bitrate needs to be if a target size was specified instead
914       calculate_bitrate_from_target_size        
915       
916       # There was a lot of experimentation to arrive at these values
917       # These seem to work OK for me. If they don't work for you, feel
918       # free to adjust/change as needed.
919
920       # Edit these as needed to suite your needs
921       mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
922       mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
923       mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
924       mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=$mencoder_threads"
925
926       # There are a number of different ways to encode 6 channel audio.
927       # I've loaded 3 different ways into the mencoder_audioch_opts.
928       # It will cycle through them until it finds one that works. 
929       # You can change the order to suit your needs.
930       if [ $audio_2ch -eq 0 ]; then
931
932         # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
933         #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
934         #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
935
936         # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
937         # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad 
938         mencoder_audio_opts="-oac copy"
939
940         # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
941         mencoder_audioch_opts[0]="-channels 6 -af channels=6"
942         mencoder_audioch_opts[1]="-af channels=6"
943         mencoder_audioch_opts[2]=""
944
945      else 
946         # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
947         mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
948         mencoder_audioch_opts[0]=""
949      fi
950
951       # Do not edit this line. $mencoder_video_encoder_opts must be last
952       mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
953       mencoder_retval=0
954
955       for PASS in 1 2 
956       do 
957         # Set some options based on which pass we are in
958         mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
959         [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
960         [ $PASS -eq 1 ] && output_file="/dev/null"
961         [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
962   
963         # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
964         for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
965         do
966           echo -e "   Encoding pass $PASS"
967           echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
968           mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
969           mencoder_retval=$? 
970           grep -q "\[channels\] Invalid" $encodelog
971           if [ $? != 0 ]; then      
972             break;
973           else
974             echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
975           fi
976         done
977         if [ $mencoder_retval != 0 ]; then
978           fatal_and_exit "-E- Unhandled mencoder error"
979         fi
980         # Concatenate the encode log to our main log file, greping out unwanted lines
981         cat $encodelog | grep -v "Pos:" >> "$logfile"
982       done
983
984       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
985         [[ -e "$vobfile" ]] && rm -f "$vobfile";
986         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
987       else
988         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
989         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
990       fi
991     fi
992
993   # add this video data to the mythtv DB
994   [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi" 
995   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
996     
997   else
998
999   # use dvdbackup to make a DVD folder of the feature title
1000   make_dvdbackup_folder_image
1001
1002   # cd to the feature title DVD folder
1003   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1004   if [ $? != 0 ]; then
1005     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1006   fi
1007   
1008   # create the dvd.xml file for dvdauthor
1009   create_dvdauthor_dvd_xml_file  
1010
1011   # make the final DVD folder image
1012   make_dvdauthor_folder_image
1013
1014   # add this video data to the mythtv DB
1015   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1016  
1017   # cd back to the dir we started from
1018   popd > /dev/null 2>&1
1019
1020   if [ $make_final_dest_iso -eq 1 ]; then
1021
1022     # make an iso image out of our directory
1023     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1024    
1025     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1026     if [ -s "$dest/$dvdname.iso" ]; then
1027       if [ $make_final_dest_folder -eq 0 ]; then
1028         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1029         # remove the folder of the DVD image now that we have a .iso version of it
1030         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1031       fi
1032     else
1033       # we created an empty iso file, remove it
1034       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1035       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1036       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1037     fi
1038  
1039     # add this video data to the mythtv DB
1040     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1041
1042   fi
1043
1044   fi
1045
1046   # remove the ddrescue DVD ISO image
1047   remove_intermediate_iso_file
1048
1049   # remove the tmp dvdbackup folder of the DVD image
1050   remove_intermediate_dvdbackup_folder
1051
1052   # eject the DVD disk upon completion
1053   [ $ripdvd -eq 1 ] && eject -T $dev
1054
1055   date=`date`
1056   echo "$date DVD rip completed" | tee -a "$logfile"
1057
1058   if [[ -n "$mailto" ]]; then
1059     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1060   fi
1061
1062 fi
1063